Ext.ns('com.blogspot.fujirou2.QuickTimePlayer');

/**
 * Media formats supported by QuickTime Player
 * http://support.apple.com/kb/HT3775
 *
 * Adding additional media format support to QuickTime
 * http://support.apple.com/kb/HT3526
 *
 */

com.blogspot.fujirou2.QuickTimePlayer.launchFn = function (param) {
	var path = param[0].get("path");

	// path is
	// /volume1/video/ELECTRIC FIRE 2007~Tribute to BASARA & MYLENE~.avi

	SYNO.SDS.AppLaunch('com.blogspot.fujirou2.QuickTimePlayer.Application', {
		fb_recs: param
	});
};

com.blogspot.fujirou2.QuickTimePlayer.Application = Ext.extend(SYNO.SDS.AppInstance, {
	appWindowName: "com.blogspot.fujirou2.QuickTimePlayer.MainWindow",
	constructor: function (cfg) {
		com.blogspot.fujirou2.QuickTimePlayer.Application.superclass.constructor.apply(this, arguments);
	}
});

com.blogspot.fujirou2.QuickTimePlayer.MainWindow = Ext.extend(SYNO.SDS.AppWindow, {
	constructor: function (cfg) {
		config = this.getConfig(cfg);
		com.blogspot.fujirou2.QuickTimePlayer.MainWindow.superclass.constructor.call(this, config);
	},
	getConfig: function (cfg) {
		var config,
			divxHtml;

		divxHtml = 'show me the money';

		config = {
			width: 600,
			height: 500,
			border: false,
			layout: 'fit',
			items: [{
				itemId: 'main',
				html: divxHtml
			}]
		};

		return config;
	},
	getMain: function () {
		return this.get('main');
	},
	bin2hex: function(path) {
		var player = this.getVideoPlayer();

		if (!player) {
			return '';
		}

		return player.bin2hex(path);
	},
	getDownloadLink: function(file_id) {
		var player = this.getVideoPlayer();

		if (!player) {
			return '';
		}

		return player.getDownloadLink(file_id);
	},
	getVideoPlayer: function() {
		if (SYNO.SDS.VideoPlayer2) {
			return SYNO.SDS.VideoPlayer2;
		} else if (SYNO.SDS.VideoPlayer) {
			return SYNO.SDS.VideoPlayer;
		}

		return null;
	},
	getHtml: function(file_id) {
		var divxHtml,
			template,
			dlLink;

		dlLink = String.format(
			'{0}//{1}{2}',
			location.protocol,
			location.host,
			this.getDownloadLink(file_id)
		);

		template = [
			'<object classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B"',
			' codebase="http://www.apple.com/qtactivex/qtplugin.cab"',
			' width="100%" height="100%">',
				'<param name="src" value="{0}"/>',
				'<param name="wmode" value="transparent"/>',

				'<embed type="video/quicktime" src="{0}"',
				' width="100%" height="100%"',
				' wmode="transparent"',
				'pluginspage="http://www.apple.com/qtactivex/qtplugin.cab">',
				'</embed>',
			'</object>'
		].join('');
		divxHtml = String.format(template, dlLink);

		return divxHtml;
	},
	playVideo: function (path, file_id) {
		this.getMain().update(this.getHtml(file_id));
	},
	onOpen: function () {
		com.blogspot.fujirou2.QuickTimePlayer.MainWindow.superclass.onOpen.apply(this, arguments);
		return this.onRequest.apply(this, arguments);
	},
	onRequest: function (param) {
		var rec;

		com.blogspot.fujirou2.QuickTimePlayer.MainWindow.superclass.onRequest.apply(this, arguments);

		if (param && param.path) {
			this.playVideo(a.path, a.file_id);
			return;
		}
		if (param  && param.fb_recs && param.fb_recs[0]) {
			rec = param.fb_recs[0];

			this.playVideo(rec.get('path'), rec.get('file_id'));
		}
	}
});

